/************************************************************/
/************************************************************/
/************************************************************/
class html
{
  private:
     char line[line_length+1];
     int  error_code;
     unsigned int  link_number;
     char string[3+1]; // 3 ---> 999 hierarchy levels
     char link[8+1];   // "link_" + 3 (from above)
  public:
     html()
        {
           error_code   = 0;
           link_number  = 0;
           line[0]      = terminator;
           string[0]    = terminator;
           strcpy(link,"link_");
        };
/*************************************************************/
int create_html(fichier* file,dir_chain* dir_header,
                                             erreur*mistake)
{
    error_code = file->open_output_file(design_list_name,mistake);
    if (error_code == 0)
       {
          create_head(file);
          create_body(file,dir_header);
          create_tail(file);
          file->close_output_file();
       }
    else;
/**/
    return error_code;
/**/
};    /*   create_html()   */
/*************************************************************/
void create_head(fichier* file)
{
   strcpy(line,
           "<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">");
   file->write_file(line);
   strcpy(line,"<html>"); 
   file->write_file(line);
   strcpy(line,"    <head>");
   file->write_file(line);
   strcpy(line,
"     <meta http-equiv=\"Content-Type\" content=\"text/html;charset=iso-8859-1\">");
   file->write_file(line);
   strcpy(line,"<title> Design List </title>");
   file->write_file(line);
   strcpy(line,"    </head>");
   file->write_file(line);
   strcpy(line,"<!-- created by me -->");
   file->write_file(line);
/**/
};   /*   create_head()  */
/*************************************************************/
void create_tail(fichier* file)
{
   strcpy(line,"<hr>");
   file->write_file(line);
   strcpy(line,"<address><small>List generated on: ");
   strcat(line,get_date_time());
   strcat(line,"by DESIGN ANALYSER ");
   strcat(line,"written by: ");
   strcat(line,"<a href=\"mailto:traurig@ieee.org\">Spyros Villios</a>");
   strcat(line,"&copy &nbsp 2003 </small></address>");
   file->write_file(line);
   strcpy(line,"<hr><hr><hr>");
   file->write_file(line);
   strcpy(line,"</body>");
   file->write_file(line);
   strcpy(line,"</html>");
   file->write_file(line);
/**/
};  /* create_tail()   */
/*************************************************************/
char* get_date_time()
{
 time_t number_seconds;
 struct tm *struktur;
/**/
 time(&number_seconds);
 struktur = localtime(&number_seconds);
/**/
 char *string = asctime(struktur);
 char *abcd = ctime(&number_seconds);
/**/
return string; // both char* are identical
/**/
};    /*   get_date_time()   */
/*************************************************************/
void create_body(fichier* file,dir_chain* dir_header)
{
  char            reference[line_length+1];
  dir_chain*      current_dir;
  file_chain*     current_file;
  module_chain*   current_module;
  instance_chain* current_instance;
/**/
   strcpy(line,"    <body bgcolor=\"#ffffffff\">");
   file->write_file(line);
   strcpy(line,"<h1 align=center> MODULE LIST: </h1>");
   file->write_file(line);
/**/
  current_dir = dir_header;
  while (current_dir != NULL)
      {
        strcpy(line,"<hr><hr><hr>");
        file->write_file(line);
        strcpy(line,"<b>Directory: </b>");
        strcat(line,current_dir->dir_name);
        file->write_file(line);
/**/
        current_file = current_dir->file_header;
        while (current_file != NULL)
            {
               strcpy(reference,current_dir->dir_name);
               strcat(reference,"/");
               strcat(reference,current_file->file_name);
              /**/
               strcpy(line,"<p><pre>");
               strcat(line,"     <b> File: </b>");
               strcat(line,current_file->file_name);
               strcat(line,"<a href=\"");
               strcat(line,reference);
               strcat(line,"\">[code]</a>");
               strcat(line,"</pre></p>");
               file->write_file(line);
/**/
               current_module = current_file->module_header;
               while (current_module != NULL)
                   {
                     strcpy(line,"<p><pre>");
                     strcat(line,"          <b> Module: </b>");
                     strcat(line,current_module->module_name);
                     strcat(line,"</pre></p>");
                     file->write_file(line);
/**/
                     current_instance =
                             current_module->instance_header;
                     if (current_instance == NULL)
                        {
                           strcpy(line,"<p><pre>");
                           strcat(line,"<b>               No Instantiations were found </b>");                         

                           strcat(line,"</pre><p>");
                           file->write_file(line);
                        }
                     else
                        create_instance_list(file,current_instance);
                     current_module = current_module->next;
                   }
               strcpy(line,"<hr>");
               file->write_file(line);
/**/
               current_file = current_file->next;
            }
/**/
        current_dir = current_dir->next;
      }
/**/
};    /*   create_body()   */
/*************************************************************/
void create_instance_list(fichier* file,instance_chain*
                                             current_instance)
{
   int             length;
/**/
   while (current_instance != NULL)
       {
          strcpy(line,"<p><pre>");
          strcat(line,"               <b>Instantiated Module: </b>");
          strcat(line,current_instance->instance_source);
          length = strlen(current_instance->instance_source);
          length = 20 - length;
          if (length <= 0)
             length = 30;
          else;
          for (int count=0; count<length; count++)
              strcat(line," ");
          strcat(line,"<b>");
          strcat(line,"Instance Name: ");
          strcat(line,"</b>");
          strcat(line,current_instance->instance_name);
          strcat(line,"</pre><p>");
          file->write_file(line);
          current_instance = current_instance->next;
       }
}; /* create_instance_list()  */
/*************************************************************/
int create_top(fichier* file,erreur*mistake)
{
   error_code = file->open_output_file(design_file_name,
                                                    mistake);
   if (error_code == 0)
      {
        create_head(file);
        create_trunk(file);
        create_tail(file);
        file->close_output_file();
      }
   else;
   return error_code;
/**/
};   /*   create_top()   */
/*************************************************************/
void create_trunk(fichier* file)
{
/**/
   strcpy(line,"    <body bgcolor=\"#ffffffff\">");
   file->write_file(line);
   strcpy(line,"<h1 align=center> CREATED DOCUMENTATION </h1>");
   file->write_file(line);
/**/
   strcpy(line,"<hr>");
   file->write_file(line);
   strcpy(line,"<pre><b> The two lists created are:</b> </pre>");
   file->write_file(line);
   strcpy(line,"<ul>");
   file->write_file(line);
   strcpy(line,"<li><a class=\"qindex\" target=\"blank\"  href=\"design_list.html\">");
   strcat(line,"Design List </a></li>");
   file->write_file(line);
//   strcpy(line,"<p></p>");
//   file->write_file(line);
   strcpy(line,"<pre><b>");
   file->write_file(line);
strcpy(line,"This list contains all modules and/or architectures entered&#13;");
strcat(line,"in the command line ordered according to the directory and&#13");
   file->write_file(line);
strcpy(line,"the file in which they were found. The files are listed as&#13");
strcat(line,"they were found in their directory (usually in alphabetical&#13");
   file->write_file(line);
strcpy(line,"order). The modules are listed as they were found in the&#13");
strcat(line,"files. Instantiated submodules are listed as they were found&#13");
   file->write_file(line);
strcpy(line,"in the module containing them.");
   file->write_file(line);
   strcpy(line,"</b></pre>");
   file->write_file(line);
   strcpy(line,"<p></p><p></p>");
   file->write_file(line);
   strcpy(line,"<li><a class=\"qindex\" href=\"design_tree.html\">");
   strcat(line,"Design Tree </a></li>");
   file->write_file(line);
   strcpy(line,"<pre><b>");
   file->write_file(line);
strcpy(line,"This contains a kind of tree of the design, starting with the&#13");
strcat(line,"top module or architecture. The top module is the one that is&#13");
   file->write_file(line);
strcpy(line,"not instantiated within another module.");
   file->write_file(line);
   strcpy(line,"</b></pre>");
   file->write_file(line);
   strcpy(line,"</ul>");
   file->write_file(line);
   strcpy(line,"<hr>");
   file->write_file(line);
/**/
};  /*  create_trunk()  */
/*************************************************************/
/*************************************************************/
void create_instance_table(fichier* file,tree* root)
{
   instance_chain* current_instance;
/**/
   strcpy(line,"<p></p>");
   file->write_file(line);
   current_instance = root->instance_header;
   if (current_instance != NULL)
      create_instance_liste(file,current_instance,root);
   else
      create_leaf(file);
   strcpy(line,"<hr>");
   file->write_file(line);
//   strcpy(line,"<a name=\"link_1\"><b>ja, ich weiss</b>");
//   strcpy(line,"<a name=\"link_2\"><b>ja ja, ich weiss</b>");
/**/
};    /* create_instance_table()  */
/*************************************************************/
void create_leaf(fichier* file)
{
  strcpy(line,"<p><pre>");
  strcat(line,"<b>No Instantiations were found </b>");
  strcat(line,"</pre><p>");
  file->write_file(line);
/**/
};   /*  create_leaf()  */
/*************************************************************/
void create_instance_liste(fichier* file,instance_chain*
                                 current_instance,tree*root)
{
   int length;
/**/

   while (current_instance != NULL)
       {
          strcpy(line,"<p><pre>");
          strcat(line,"<b>Instantiated Module: </b>");
          strcat(line,current_instance->instance_source);
          strcat(line,"<a href=\"#");
          strcat(line,link);
          link_number++;
          int_to_alpha(link_number,string);
          save_link(string,root);
          strcat(line,string);
          strcat(line,"\">[subtree]</a>");
          length = strlen(current_instance->instance_source);
          length = 20 - length;
          if (length <= 0)
             length = 30;
          else;
          for (int count=0; count<length; count++)
              strcat(line," ");
          strcat(line,"<b>");
          strcat(line,"Instance Name: ");
          strcat(line,"</b>");
          strcat(line,current_instance->instance_name);
          strcat(line,"</pre><p>");
          file->write_file(line);
          current_instance = current_instance->next;
       }
}; /* create_instance_list()  */
/*************************************************************/
void create_dir_file(fichier* file,tree* root)
{
  strcpy(line,"<p></p>");
  file->write_file(line);
  strcpy(line,"<b>Found In Dir:    </b>");
  strcat(line,root->dir_name);
  strcat(line,"               ");
  strcat(line,"<b>In File: </b>");
  strcat(line,root->file_name);
  strcat(line,"<a href=\"");
  strcat(line,root->dir_name);
  strcat(line,"/");
  strcat(line,root->file_name);
  strcat(line,"\">[code]</a>");
  strcat(line,"&#13");
  file->write_file(line);
  strcpy(line,"</pre>");
  file->write_file(line);
/**/
};  /* create_dir_file()   */
/*************************************************************/
void create_capo(fichier* file,tree* root)
{
  create_head(file);
  strcpy(line,"    <body bgcolor=\"#ffffffff\">");
  file->write_file(line);
  strcpy(line,"<h1 align=center> CREATED TREE </h1>");
  file->write_file(line);
  strcpy(line,"<hr><hr><hr>");
  file->write_file(line);
/**/
  strcpy(line,"<pre><b>Top Design Unit: </b>");
  strcat(line,root->module_name);
  strcat(line,"&#13");
  file->write_file(line);
/**/
};   /* create_capo()  */
/*************************************************************/
void create_subtree(fichier*file,tree*root,hyperlink*link_pointer)
{
  strcpy(line,"<a name=\"");
  strcat(line,link);
  strcat(line,link_pointer->link_number);
  strcat(line,"\"> ");
  file->write_file(line);

//                   link_1\"><b>ja, ich weiss</b>");
  strcpy(line,"<pre><b>Design Unit: </b>");
  strcat(line,root->module_name);
  strcat(line,"         <b> Instance Name: </b>");
  strcat(line,root->instance_name);
  strcat(line,"&#13");
  file->write_file(line);
  create_dir_file(file,root);
  create_instance_table(file,root);
/**/
};   /*  create_subtree()  */
/*************************************************************/
void save_link(char string[],tree* root)
{
  hyperlink* current_link;
/**/
  current_link = new hyperlink;
  strcpy(current_link->link_number,string);
  current_link->next = NULL;
  if (root->link_header != NULL)
     {
       hyperlink* current;
       hyperlink* previous;
       current = root->link_header;
       while (current != NULL)
           {
cout << "current = " << current->link_number << endl;
              previous  = current;
              current   = current->next;
           }
       previous->next = current_link;
     }
  else
     root->link_header = current_link;
/**/
};  /*  save_link()  */
/*************************************************************/
void int_to_alpha(unsigned int number,char string[])
{
int  count;
int  count1;
int  base;
char tempor;
/**/  // if number == 0 this routine breaks down
base  = 10;
count =  0;
while (number > 0)
    {
      string[count++] = (number % base) + '0';
      number /= base;
    }
string[count] = terminator;
/**/
count--;
cout << "count is = " << count << endl;
int middle = count / 2;
   for (count1=0; count1<=middle; count1++,count--)
       {
         tempor = string[count1];
         string[count1] = string[count];
         string[count] = tempor;
       }
/**/
};   /*  int_to_alpha()  */
/*************************************************************/
}; /* end class html  */
/*************************************************************/
/*************************************************************/
/*************************************************************/
