/***************************************************************/
/***************************************************************/
/***************************************************************/
/*
Please note: Each instantiation of a module within another will
be recorded separately, even instantiations of the same module.
/**
Please note: In the structure "instance_chain" below,
"instance_source" is the name of a module that is instantiated
within another module,
"instance_name" is the name of the particular instance.
/**
In case of VHDL:
In the struct "instance_chain:
"instance_source" is the entity name of the instantiation.
"instance_name"   is the name of the label.This label is
what tells apart instantiations of one subunit inside a unit.
"instance_archit" is the name of the architecture that belongs
to the entity stored in "instance_source".
*/
/***************************************************************/
struct instance_chain // one for each instance of a module
     {                // within a module
        char*           instance_source; // instantiated module.
        char*           instance_name;   // name of the instance.
        char*           instance_archit; 
        instance_chain* next;
     };
/***************************************************************/
struct module_chain  // one for each module ( entity/architecture
                     // pair) found in a file
     {
        char*           module_name;
        char*           entity_name;
        char*           archit_name;
        instance_chain* instance_header;
        module_chain*   next;
     };
/***************************************************************/
 struct file_chain   // one for each file in a directory
     {
        char*         file_name;
        module_chain* module_header;
        file_chain*   next; 
     };
/***************************************************************/
struct dir_chain     // one for each different directory entered
     {
        char*       dir_name;
        file_chain* file_header;
        dir_chain*  next;
     };
/***************************************************************/
/***************************************************************/
/***************************************************************/
struct hyperlink
     {
        char link_number[3+1];
        hyperlink* next;
     };
/***************************************************************/
struct tree
     {
        char*           dir_name;
        char*           file_name;
        char*           module_name;
        char*           instance_name;
        hyperlink*      link_header;
        instance_chain* instance_header;
     };
/***************************************************************/
/***************************************************************/
/***************************************************************/
