#include "generic.h"
#include "link.h"
#include "error.h"
#include "vhdl_scanner.h"
#include "verilog_scanner.h"
#include "file.h"
#include "html.h"
#include "output.h"
#include "garbage_collector.h"
/******************************************************************/
/******************************************************************/
/******************************************************************/
class starter
{
   private:
         enum
            {
               file_limit        = 200,
               dir_string_length =  80
            };
         int        v_only;
         int        vhdl_only;
         int        mixed;
         int        error_code;
         int        number_file_entries;
         char*      current_dir;
         char*      file_entries[file_limit];
         dir_chain* dir_header;
         erreur*    mistake;  // erreur  is French for error.
         fichier*   file;     // fichier is French for file.
         out*       output;
         collector* garbage;

   public:
       starter()
          {
             error_code          = 0;
             number_file_entries = 0;
             v_only              = no;
             vhdl_only           = no;
             mixed               = no;
 //            current_dir         = ".";
             current_dir         = NULL;
        current_dir = (char*)  malloc(dir_string_length+1);
             dir_header          = NULL;
             mistake             = new erreur;
             file                = new fichier;
             output              = new out;
             garbage             = new collector;
          };
       ~starter()
          {
     //        garbage->delete_dir_chain(dir_header);
             delete garbage;
             delete mistake;
             delete file;
          };
/******************************************************************/
int do_the_job(int number_entries,char** entries)
   {
     if (entries[1][0] == dash)
        if (entries[1][1] == 'f')
           if (number_entries == 2)
              error_code = mistake->print_error_message(16);
           else if (number_entries > 3)
              error_code = mistake->print_error_message(17);
           else
              {
                 error_code = file->open_input_file(entries[2],mistake);
                 if (error_code == 0)
                    {
                        error_code = file->get_entries(file_limit,
                                         number_file_entries,
                                    file_entries,mistake,entries[2]);
                        file->close_input_file();
                    }
                 else;
              }
        else
           error_code = mistake->print_error_message(11,entries[1]);
     else
        {
           number_file_entries = number_entries - 1;
           for (int count=1; count<=number_file_entries; count++)
               file_entries[count-1] = entries[count];
        }
/**/
/**/
/**/
     if (error_code == 0)
        {
           error_code = check_for_dollar(number_file_entries,file_entries);
           if (error_code == 0)
              {
puts("DOLLAR CHECKED");
        for (int count=0; count<number_file_entries; count++)
            cout << file_entries[count] << endl;
                 error_code = check_for_wildcard(number_file_entries,
                                                      file_entries);
                 if (error_code == 0)
                    {
puts("WILDCARD CHECKED");
                       error_code = check_for_doubles(
                                    number_file_entries,file_entries);
                       if (error_code == 0)
                          {
                             error_code = check_entries(
                                   number_file_entries,file_entries);
                             if (error_code == 0)
                                {
            for (int count=0; count<number_file_entries; count++)
                cout << file_entries[count] << endl;
//exit(0);
                                   error_code = check_for_existence(
                                                number_file_entries,
                                                file_entries);
                                   if (error_code == 0)
                                      {
                                         error_code = collect_data();
                                         if (error_code == 0)
                                            {
                                               display_collected_data();
                                               error_code =
                                                  create_html_file();
                                               if (error_code == 0)
                                                  {
                                                     error_code =
                                                       output->create_output(file,
                                                           dir_header,mistake);
                                                     if (error_code == 0)
                                                        error_code =
                                                          create_top_file(file,
                                                               mistake);
                                                     else;
                                                  }
                                               else;
                                            }
                                         else;
                                     }
                                  else;
                                }
                             else;
                          }
                       else;
                    }
                 else;
              }
           else;
        }
     else;
/**/
             return error_code;
/**/               
   };   /*  do_the_job()   */
/******************************************************************/
int check_for_dollar(int number_entries, char*entries[])
{
  int     count;
/**/
  for (count=0; count<number_entries; count++)
      if (strchr(entries[count],dollar))
         {
            puts("Dollar found");
            error_code = resolve_path(entries[count]);
            
         }
      else
         puts("Dollar was not entered");

cout << endl;
for (count=0; count<number_entries; count++)
    cout << "&&&&&" << entries[count] << "&&&&&" << endl;
cout << endl;

//exit(0);
/**/
   return error_code;
/**/
};   /*   check_for_dollar()   */
/******************************************************************/
int check_for_wildcard(int& number_entries, char*entries[])
{
  int     count;
  int     star_found;
  int     number_star_entries;
  char *  star_entries[file_limit];
/**/
  star_found = no;
  number_star_entries = 0;
  for (count=0; count<number_entries; count++)
      if (strchr(entries[count],star))
         {
            puts("Star found");
            star_found = yes;
            error_code = get_star_entries(number_star_entries,
                                star_entries,entries[count]);
            
         }
      else
         {
            puts("No star found in this line");
            star_entries[number_star_entries++] = entries[count];
         }
/**/
if (star_found == yes)
   {
      for (count=0; count<number_entries; count++)
          delete [] entries[count];
/**/
      for (count=0; count<number_star_entries; count++)
          entries[count] = star_entries[count];
      number_entries = number_star_entries;
   }
else;
/**/
   return error_code;
/**/
};   /*   check_for_wildcard()   */
/******************************************************************/
int get_star_entries(int& number_star_entries,char*star_entries[],
                                          char star_entry[])
{

  char    dir_name[line_length+1];
  char    file_name[line_length+1];
  DIR *   directory;
  dirent* struktur;
/**/
  if (strchr(star_entry,slash) != NULL)
     error_code = get_dir_file_names(dir_name,file_name,star_entry);
  else
     {
        current_dir = getcwd(current_dir,dir_string_length);
        strcpy(dir_name,current_dir);
        strcpy(file_name,star_entry);
     }
/**/
  if (error_code == 0)
     {
       char xxx[200];
       strcpy(xxx,dir_name);
       xxx[20] = terminator;
puts("IS THAT THE PLACE????");
       directory = opendir("v_code");
       if (directory == NULL)
          if (errno == ENOENT) 
             error_code =
                    mistake->print_error_message(3,dir_name);
          else if (errno == ENOMEM)
             error_code =
                    mistake->print_error_message(4,dir_name);
          else if (errno == EACCES)
             puts("no access");
          else if (errno == EMFILE)
             puts("too many file descriptors");
          else if (errno == ENFILE)
             puts("too many files open");
          else if (errno == ENOTDIR)
             puts("name not a directory");
          else
             error_code =
                    mistake->print_error_message(5,dir_name);
       else
          {
             rewinddir(directory);
             struktur = NULL;
             struktur = readdir(directory); //get rid of "."
             struktur = readdir(directory); //get rid of ".."
             struktur = NULL;
             struktur = readdir(directory); //read first entry
             if (struktur == NULL)
                {
                   error_code =
                         mistake->print_error_message(6,dir_name);
                   error_code =
                         mistake->print_error_message(7,dir_name);
                }
             else
                {
                   char* pointer;
                   pointer = strchr(file_name,point);
                   if (pointer != NULL)
                      {
                        char* zeiger;
                        pointer++;
                        while (struktur != NULL)
                            {
                               zeiger = strchr(struktur->d_name,point);
                               if (zeiger != NULL)
                                  {
                                     zeiger++;
                                     if (strcmp(zeiger,pointer) == 0)
                                        {
                                           star_entries[number_star_entries] = new
                                                 char [strlen(dir_name)+ strlen(
                                                 struktur->d_name)+1+1];
                                           strcpy(star_entries[number_star_entries],
                                                      dir_name);
                                           strcat(star_entries[number_star_entries],
                                                      "/");
                                           strcat(star_entries[number_star_entries++],
                                                struktur->d_name);
                                        }
                                     else;
                                  }
                               else;
                               struktur = readdir(directory);
                            }
                      }
                   else
                      error_code = mistake->print_error_message(22,star_entry);
                   if ((error_code == 0) && (number_star_entries == 0))
                      error_code =
                         mistake->print_error_message(20,dir_name,pointer);
                   else;
                }
          }
     }
  else;
  closedir(directory);
/**/
  if (current_dir != NULL)
     free(current_dir);
  else;
/**/
  return error_code;
/**/
};    /*   get_star_entries()  */
/******************************************************************/
int check_entries(int number_entries,char** entries)
   {
      int   count;
      int   h_found;
      int   v_found;
      int   vhdl_found;
      char* extension;
/**/
       error_code = 0;
       h_found = v_found = vhdl_found = 0;
       count = (-1);
       while ((error_code == 0) && ((++count) < number_entries))
           {
              extension = strchr(entries[count],terminator);
              while (!is_point(*extension))
                  extension--;
              extension++; 
              if (is_verilog(extension))
                 v_found++;
              else if (is_vihdl(extension))
                 vhdl_found++;
              else if (is_h(extension))
                 h_found++;
              else
                 error_code = 1;
           }
/**/
       if (error_code == 0)
          if (h_found == (count))
             error_code = mistake->print_error_message(0);
          else if ((v_found + h_found) == count)
             v_only = yes;
          else if (vhdl_found == count)
             vhdl_only = yes;
          else if (((v_found + h_found) + vhdl_found) == count)
             mixed = yes;
          else
             error_code = 1;
       else
          error_code = mistake->print_error_message(1,entries[count]);
/**/
       return error_code;
/**/
   };   /*   check_entries()   */
/******************************************************************/
int check_for_existence(int number_entries,char** entries)
   {
      int     count; 
      DIR *   directory;
      dirent* struktur;
      char    dir_name[line_length+1];
      char    file_name[line_length+1];
/**/
/**/
      count = (-1);
      while ((error_code == 0) && ((++count) <= (number_entries-1)))
          {
             if (strchr(entries[count],slash) != NULL)
                   error_code = get_dir_file_names(dir_name,
                                            file_name,entries[count]);
             else
                {
                   current_dir = getcwd(current_dir,dir_string_length);
                   strcpy(dir_name,current_dir);
                   strcpy(file_name,entries[count]);
                }
             if (error_code == 0)
                {
                   directory = opendir(dir_name);
                   if (directory == NULL)
                      if (errno == ENOENT) 
                          error_code =
                                mistake->print_error_message(3,dir_name);
                      else if (errno == ENOMEM)
                         error_code =
                                mistake->print_error_message(4,dir_name);
                      else
                         error_code =
                                mistake->print_error_message(5,dir_name);
                   else
                      {
                        rewinddir(directory);
                        struktur = NULL;
                        struktur = readdir(directory); //get rid of "."
                        struktur = readdir(directory); //get rid of ".."
                        struktur = NULL;
                        struktur = readdir(directory); //read first entry
                        if (struktur == NULL)
                           {
                             error_code =
                                mistake->print_error_message(6,dir_name);
                             error_code =
                                mistake->print_error_message(7,dir_name);
                            }
                         else
                            {
                              int found;
                              found = no;
                              while ((found == no) && (struktur != NULL))
                                  if (strcmp(struktur->d_name,file_name) == 0)
                                     found = yes;
                                  else
                                     struktur = readdir(directory);
                              if (found == no)
                                 error_code =
                               mistake->print_error_message(8,file_name);
                              else;
                            }
                      }
                }
             else;
             closedir(directory);
             if (error_code == 0)
// directory exists and the file(s) was found in it,
// put their names in to the chain:
                error_code = put_into_chain(dir_name,file_name);
             else;
         }
     if (current_dir != NULL)
        free(current_dir);
     else;
      return error_code;
   };    /* check_for_existence()   */
/******************************************************************/
int resolve_path(char entry[])
  {
     int   count;
     char* value;
     char  dir_name[line_length+1];
     char  file_name[line_length+1];
/**/
     count = 1;  // 0th element is: $
     while ((isalnum(entry[count])) || (is_underscore(entry[count])))
           count++;
     if (!is_slash(entry[count]))
        error_code = mistake->print_error_message(10,entry);
     else
        {
           char name[20];
           strncpy(name,&entry[1],count-1);
           name[count-1] = terminator;

           value = getenv(name);
           if (value == NULL)
              error_code = mistake->print_error_message(23,name);
           else
              {
                 strcpy(dir_name,value);
                 int count1;
                 count1 = strlen(entry);
                 while (!is_slash(entry[count1--]));
                 strcpy(file_name,&entry[count1+1+1]);
                 if (count1 > (count+1))
                    strncat(dir_name,&entry[count],count1-count+1);
                 else
                    error_code = mistake->print_error_message(10,&entry[count+1]);
              }
       }
      strcpy(entry,dir_name);
      strcat(entry,"/");
      strcat(entry,file_name);
/**/
      return error_code;
/**/
  };   /*   resolve_path()   */
/******************************************************************/
int check_for_doubles(int number_entries,char** entries)
   {
     int count;
     int count1;
/**/
     count = (-1) ;
     while ((error_code == 0) && ((++count) <= (number_entries-1)))
         {
            count1 = count;
            while ((error_code == 0) && ((++count1) <= (number_entries-1)))
                if (strcmp(entries[count],entries[count1]) == 0)
                    error_code = 1;
                else;
          }
     if (error_code == 1)
        mistake->print_error_message(2,entries[count]);
     else;
     return error_code;
          };   /* check_for_doubles()   */
/******************************************************************/
int get_dir_file_names(char dir_name[],char file_name[],char* entry)
   {
      int count;
      int count1;
      int length;
      int length1;
/**/
//                                    add_link_to_dir_chain();
      length = strlen(entry);
      count = length;
      while (entry[count] != slash)
            count--;
      if (count != length)
         {
            strncpy(dir_name,entry,count);
            dir_name[count] = terminator;
cout << "directory name is = " << dir_name << endl;
            length1 = strlen(&entry[count+1]);
            strcpy(file_name,&entry[count+1]);
cout << "file name is = " << file_name << endl;
         }
      else
         error_code = mistake->print_error_message(9,entry);
/**/
      return error_code;
   };    /*   get_dir_file_names()   */
/******************************************************************/
        int scan_file_chain(dir_chain* dir_pointer,char file_name[])
           {
//cout << "File name to be stored is = " << file_name << endl;
              if (dir_pointer->file_header == NULL)
                 {
                    int   length;
                    char* string;
                    file_chain* file_pointer;
                    file_pointer = new file_chain;
                    file_pointer->module_header = NULL;
                    file_pointer->next          = NULL;
                    dir_pointer->file_header    = file_pointer;
                    length = strlen(file_name);
                    string = new char [length+1];
                    strcpy(string,file_name);
                    file_pointer->file_name = string;
                    
                 }
              else
                 {
                    int found;
                    file_chain* file_pointer;
                    file_chain* previous;
                    found = no;
                    file_pointer = dir_pointer->file_header;
                    while ((file_pointer != NULL) && (found = no))
                        if (strcmp(file_pointer->file_name,file_name) != 0)
                           {
                              previous = file_pointer;
                              file_pointer = file_pointer->next;
                           }
                        else
                           found = yes;
                    if (found = no)
                       {
                          int length;
                          char *string;
                          file_pointer = new file_chain;
                          file_pointer->module_header = NULL;
                          file_pointer->next          = NULL;
                          length = strlen(file_name);
                          string = new char [length+1];
                          strcpy(string,file_name);
                          file_pointer->file_name = string;
                          previous->next = file_pointer;
                       }
                    else
                       error_code = mistake->print_error_message(2,file_name);
                 }
/*
file_chain *file_pointer;
file_pointer = dir_pointer->file_header;
while (file_pointer != NULL)
    {
     cout << "File name stored is = " << file_pointer->file_name << endl;
        file_pointer = file_pointer->next;
    }
*/
              return error_code;
           }; /*   scan_file_chain()  */
/******************************************************************/
dir_chain* scan_dir_chain(char dir_name[])
   {
      dir_chain* pointer;
      if (dir_header != NULL)
         {
            int found;
            dir_chain* previous;
/**/
            found    = no;
            pointer  = dir_header;
            while ((pointer != NULL) && (found == no))
            if (strcmp(pointer->dir_name,dir_name) != 0)
               {
                  previous = pointer;
                  pointer = pointer->next;
               }
            else
               found = yes;
            if (found == no) //add a new link to the dir chain
               {
                  int   length;
                  char *string;
                  pointer = previous->next;
                  pointer = new dir_chain;
                  pointer->file_header = NULL;
                  pointer->next        = NULL;
                  length = strlen(dir_name);
                  string = new char [length+1];
                  strcpy(string,dir_name);
                  pointer->dir_name = string;
               }
            else; //dir previously found, no action necessary.
         }
      else  // very first time I am here
         {
            int   length;
            char *string;
            pointer = new dir_chain;
            pointer->file_header = NULL;
            pointer->next        = NULL;
            length = strlen(dir_name);
            string = new char [length+1];
            strcpy(string,dir_name);
            pointer->dir_name = string;
            dir_header = pointer;   
          }
/**/
              return pointer;
/**/
   };  /*  scan_dir_chain()  */
/******************************************************************/
int put_into_chain(char dir_name[],char file_name[])
   {
     dir_chain* dir_pointer;
     dir_pointer = scan_dir_chain(dir_name);
/**/
//cout << "Directory is = " << dir_pointer->dir_name << endl;
//cout << "And the corresponding file name = " << file_name << endl;
/**/
     return scan_file_chain(dir_pointer,file_name);
   };   /*  put_into_chain()   */
/******************************************************************/
char* put_together(dir_chain* dir_pointer,file_chain* file_pointer)
  {
    char* path;

    path = new char [strlen(dir_pointer->dir_name)+1+
                              strlen(file_pointer->file_name)];
cout << "heap space for path was just allocated" << endl;
    strcpy(path,dir_pointer->dir_name);
cout << " PATH IS =" << path << endl;
    strcat(path,"/");
    strcat(path,file_pointer->file_name);
cout << "Created path is = " << path << endl;
    return path;
  };  /*   put_together() */
/******************************************************************/
int do_it(file_chain* file_pointer,char *path)
  {
     error_code = file->open_input_file(path,mistake);
     if (error_code == 0)
        {
          scan *scanner = new scan;
          error_code = file->read_file(file_pointer,
                                             mistake,scanner);
          file->close_input_file();
          delete scanner;
        }
     else;
/**/
     return error_code;
  };  /*  do_it()  */
/******************************************************************/
int collect_data()
   {
     char * path;
     path = NULL;
     dir_chain* dir_pointer;
     file_chain* file_pointer;
     dir_pointer = dir_header;
     while (dir_pointer != NULL)
         {
            file_pointer = dir_pointer->file_header;
            while (file_pointer != NULL)
                {
//cout << "HOW MANY FILES HOW MANY FILES HOW MANY FILES HOW MANY FILES" << endl;
cout << "path is =" << path << endl;
                   if (path != NULL)
            ;//          delete [] path;
                   else;
//cout << "dir_pointer =" << dir_pointer << "##     file_pointer =" <<
  //                           file_pointer << "##" << endl;
                    path = put_together(dir_pointer,file_pointer);
//cout <<"created path is =" << path << "*****" << endl;
                    do_it(file_pointer,path);
//cout <<"I did it   I did it    I did it" << endl;
                    file_pointer = file_pointer->next;
                }
            dir_pointer = dir_pointer->next;
         }
     return error_code;
  };    /*   collect_data()   */
/******************************************************************/
void display_collected_data()
   {
      int length;
      dir_chain* current_dir;
      file_chain* current_file;
      module_chain* current_module;
      instance_chain* current_instance;
/**/
     cout << "COLLECTED DATA:" << endl << endl;
     current_dir = dir_header;
     while (current_dir != NULL)
         {
            cout << "Directory: " << current_dir->dir_name
                                                   << endl;
            current_file = current_dir->file_header;
            while (current_file != NULL)
                {
                   cout << "       File: " <<
                                      current_file->file_name
                                                   << endl;
                   current_module = current_file->module_header;
                   while (current_module != NULL)
                       {
                          cout << "           Module: " <<
                                  current_module->module_name
                                                     << endl;
                          current_instance =
                               current_module->instance_header;
                          while (current_instance != NULL)
                              {
                                 cout << "               ";
                                 cout << "Instantiated Module: ";
                                 cout << current_instance->instance_source;
                                length = strlen(current_instance->instance_source);
                                 length = 20 - length;
                                 if (length <= 0)
                                    length = 30;
                                 else;
                                 for (int count=0; count<length; count++)
                                     cout << " ";
                                 cout << "Instance Name: ";
                                 cout << current_instance->instance_name;
                                 cout << endl;
                                      current_instance =
                                         current_instance->next;
                               }
                          current_module = current_module->next;
                       }
                  current_file = current_file->next;
                }
           current_dir = current_dir->next;
         }
      cout << endl << endl;
/**/
   };  /* display_collected_data()   */
/******************************************************************/
int create_html_file()
{
/**/
    html*  abcde = new html;
    error_code = abcde->create_html(file,dir_header,mistake);
    delete abcde;
    return error_code;
/**/
};  /*  create_html_file()  */
/******************************************************************/
int create_top_file(fichier*file,erreur* mistake)
{
/**/
    html*  abcde = new html;
    error_code = abcde->create_top(file,mistake);
    delete abcde;
    return error_code;
/**/
};   /*  create_top_file()   */
/******************************************************************/
};   /*  end class starter  */
/******************************************************************/
/******************************************************************/
/******************************************************************/
